diff --git a/src/main/java/net/minecraft/core/net/packet/Packet39AttachEntity.java b/src/main/java/net/minecraft/core/net/packet/SetRidingPacket.java
similarity index 71%
rename from src/main/java/net/minecraft/core/net/packet/Packet39AttachEntity.java
rename to src/main/java/net/minecraft/core/net/packet/SetRidingPacket.java
index 0711500c1..abca2c753 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet39AttachEntity.java
+++ b/src/main/java/net/minecraft/core/net/packet/SetRidingPacket.java
@@ -1,28 +1,28 @@
 package net.minecraft.core.net.packet;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet39AttachEntity extends Packet
+public class SetRidingPacket extends Packet
 {
 
-    public Packet39AttachEntity()
+    public SetRidingPacket()
     {
     }
     
-    public Packet39AttachEntity(Entity passenger, Entity vehicle)
+    public SetRidingPacket(Entity passenger, Entity vehicle)
     {
         passengerId = passenger.id;
         vehicleId = vehicle == null ? -1 : vehicle.id;
         isTileEntity = false;
     }
 
-    public Packet39AttachEntity(Entity passenger, int x, int y, int z)
+    public SetRidingPacket(Entity passenger, int x, int y, int z)
     {
         passengerId = passenger.id;
         this.x = x;
@@ -32,13 +32,13 @@ public class Packet39AttachEntity extends Packet
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 8;
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         passengerId = dis.readInt();
@@ -53,7 +53,7 @@ public class Packet39AttachEntity extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeInt(passengerId);
@@ -68,9 +68,9 @@ public class Packet39AttachEntity extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleAttachEntity(this);
+        packetHandler.handleAttachEntity(this);
     }
 
     public int passengerId;
diff --git a/src/main/java/net/minecraft/core/net/packet/SetSpawnPositionPacket.java b/src/main/java/net/minecraft/core/net/packet/SetSpawnPositionPacket.java
new file mode 100644
index 000000000..1b2c175cb
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/packet/SetSpawnPositionPacket.java
@@ -0,0 +1,57 @@
+package net.minecraft.core.net.packet;
+
+import net.minecraft.core.net.handler.PacketHandler;
+
+import java.io.*;
+
+// Referenced classes of package net.minecraft.src:
+//            Packet, PacketHandler
+
+public class SetSpawnPositionPacket extends Packet
+{
+    public int x;
+    public int y;
+    public int z;
+
+
+    public SetSpawnPositionPacket()
+    {
+    }
+
+    public SetSpawnPositionPacket(int x, int y, int z)
+    {
+        this.x = x;
+        this.y = y;
+        this.z = z;
+    }
+
+    @Override
+	public void read(DataInputStream dis)
+        throws IOException
+    {
+        x = dis.readInt();
+        y = dis.readInt();
+        z = dis.readInt();
+    }
+
+    @Override
+	public void write(DataOutputStream dos)
+        throws IOException
+    {
+        dos.writeInt(x);
+        dos.writeInt(y);
+        dos.writeInt(z);
+    }
+
+    @Override
+	public void handlePacket(PacketHandler packetHandler)
+    {
+        packetHandler.handleSpawnPosition(this);
+    }
+
+    @Override
+	public int getEstimatedSize()
+    {
+        return 12;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet4UpdateTime.java b/src/main/java/net/minecraft/core/net/packet/SetTimePacket.java
similarity index 50%
rename from src/main/java/net/minecraft/core/net/packet/Packet4UpdateTime.java
rename to src/main/java/net/minecraft/core/net/packet/SetTimePacket.java
index dade2fa0b..99e04c377 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet4UpdateTime.java
+++ b/src/main/java/net/minecraft/core/net/packet/SetTimePacket.java
@@ -1,49 +1,49 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet4UpdateTime extends Packet
+public class SetTimePacket extends Packet
 {
+    public long time;
+
 
-    public Packet4UpdateTime()
+    public SetTimePacket()
     {
     }
-    
-    public Packet4UpdateTime(long l)
+
+    public SetTimePacket(long l)
     {
         time = l;
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         time = dis.readLong();
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeLong(time);
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleUpdateTime(this);
+        packetHandler.handleUpdateTime(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 8;
     }
-
-    public long time;
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet130UpdateSign.java b/src/main/java/net/minecraft/core/net/packet/SignUpdatePacket.java
similarity index 74%
rename from src/main/java/net/minecraft/core/net/packet/Packet130UpdateSign.java
rename to src/main/java/net/minecraft/core/net/packet/SignUpdatePacket.java
index c598d60ae..c3c0fb1af 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet130UpdateSign.java
+++ b/src/main/java/net/minecraft/core/net/packet/SignUpdatePacket.java
@@ -1,21 +1,21 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet130UpdateSign extends Packet
+public class SignUpdatePacket extends Packet
 {
 
-    public Packet130UpdateSign()
+    public SignUpdatePacket()
     {
         isChunkDataPacket = true;
     }
 
-    public Packet130UpdateSign(int x, int y, int z, String[] lines, int picture, int color)
+    public SignUpdatePacket(int x, int y, int z, String[] lines, int picture, int color)
     {
         isChunkDataPacket = true;
         xPosition = x;
@@ -27,7 +27,7 @@ public class Packet130UpdateSign extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         xPosition = dis.readInt();
@@ -43,7 +43,7 @@ public class Packet130UpdateSign extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeInt(xPosition);
@@ -58,13 +58,13 @@ public class Packet130UpdateSign extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleUpdateSign(this);
+        packetHandler.handleUpdateSign(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         int i = 0;
         for(int j = 0; j < 4; j++)
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet17Sleep.java b/src/main/java/net/minecraft/core/net/packet/SleepPacket.java
similarity index 57%
rename from src/main/java/net/minecraft/core/net/packet/Packet17Sleep.java
rename to src/main/java/net/minecraft/core/net/packet/SleepPacket.java
index af0c1f3b5..cd5486f41 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet17Sleep.java
+++ b/src/main/java/net/minecraft/core/net/packet/SleepPacket.java
@@ -1,11 +1,11 @@
 package net.minecraft.core.net.packet;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
-public class Packet17Sleep extends Packet {
+public class SleepPacket extends Packet {
 
 	public int entityID;
 	public int x;
@@ -13,9 +13,9 @@ public class Packet17Sleep extends Packet {
 	public int z;
 	public int field_22046_e;
 
-	public Packet17Sleep() {}
+	public SleepPacket() {}
 
-	public Packet17Sleep(Entity entity, int i, int x, int y, int z) {
+	public SleepPacket(Entity entity, int i, int x, int y, int z) {
 		this.field_22046_e = i;
 		this.x = x;
 		this.y = y;
@@ -24,7 +24,7 @@ public class Packet17Sleep extends Packet {
 	}
 
 	@Override
-	public void readPacketData(DataInputStream dis) throws IOException {
+	public void read(DataInputStream dis) throws IOException {
 		entityID = dis.readInt();
 		field_22046_e = dis.readByte();
 		x = dis.readInt();
@@ -33,7 +33,7 @@ public class Packet17Sleep extends Packet {
 	}
 
 	@Override
-	public void writePacketData(DataOutputStream dos) throws IOException {
+	public void write(DataOutputStream dos) throws IOException {
 		dos.writeInt(entityID);
 		dos.writeByte(field_22046_e);
 		dos.writeInt(x);
@@ -42,12 +42,12 @@ public class Packet17Sleep extends Packet {
 	}
 
 	@Override
-	public void processPacket(NetHandler netHandler) {
-		netHandler.handleSleep(this);
+	public void handlePacket(PacketHandler packetHandler) {
+		packetHandler.handleSleep(this);
 	}
 
 	@Override
-	public int getPacketSize() {
+	public int getEstimatedSize() {
 		return 17;
 	}
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/StatisticPacket.java b/src/main/java/net/minecraft/core/net/packet/StatisticPacket.java
new file mode 100644
index 000000000..aef0545f3
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/packet/StatisticPacket.java
@@ -0,0 +1,60 @@
+package net.minecraft.core.net.packet;
+
+import net.minecraft.core.net.handler.PacketHandler;
+import net.minecraft.core.util.HardIllegalArgumentException;
+import net.minecraft.core.util.collection.NamespaceID;
+
+import java.io.*;
+
+// Referenced classes of package net.minecraft.src:
+//            Packet, PacketHandler
+
+public class StatisticPacket extends Packet
+{
+    public NamespaceID statID;
+    public int valueChange;
+
+
+    public StatisticPacket()
+    {
+    }
+
+    public StatisticPacket(NamespaceID statID, int change)
+    {
+        this.statID = statID;
+        valueChange = change;
+    }
+
+
+    @Override
+	public void handlePacket(PacketHandler packetHandler)
+    {
+        packetHandler.handleStatistic(this);
+    }
+
+    @Override
+	public void read(DataInputStream dis)
+        throws IOException
+    {
+        try {
+            statID = new NamespaceID(readString(dis, Integer.MAX_VALUE));
+        } catch (HardIllegalArgumentException e) {
+            statID = null;
+        }
+        valueChange = dis.readByte();
+    }
+
+    @Override
+	public void write(DataOutputStream dos)
+        throws IOException
+    {
+        writeString(statID.toString(), dos);
+        dos.writeByte(valueChange);
+    }
+
+    @Override
+	public int getEstimatedSize()
+    {
+        return 6;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet201Ids.java b/src/main/java/net/minecraft/core/net/packet/SyncIDsPacket.java
similarity index 79%
rename from src/main/java/net/minecraft/core/net/packet/Packet201Ids.java
rename to src/main/java/net/minecraft/core/net/packet/SyncIDsPacket.java
index 88a3eb838..b5abb0235 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet201Ids.java
+++ b/src/main/java/net/minecraft/core/net/packet/SyncIDsPacket.java
@@ -7,16 +7,16 @@ import java.util.HashMap;
 import java.util.Map;
 import java.util.Map.Entry;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.sound.SoundTypes;
 
-public class Packet201Ids extends Packet {
+public class SyncIDsPacket extends Packet {
 
 	public Map<String, Integer> soundIds;
 	private int packetSize;
 	
 	@Override
-	public void readPacketData(DataInputStream in) throws IOException {
+	public void read(DataInputStream in) throws IOException {
 		int size = 0;
 		
 		size += readSoundIds(in);
@@ -25,7 +25,7 @@ public class Packet201Ids extends Packet {
 	}
 
 	@Override
-	public void writePacketData(DataOutputStream out) throws IOException {
+	public void write(DataOutputStream out) throws IOException {
 		int size = 0;
 		
 		size += writeSoundIds(out);
@@ -67,12 +67,12 @@ public class Packet201Ids extends Packet {
 	}
 
 	@Override
-	public void processPacket(NetHandler netHandler) {
-		netHandler.handleIds(this);
+	public void handlePacket(PacketHandler packetHandler) {
+		packetHandler.handleIds(this);
 	}
 
 	@Override
-	public int getPacketSize() {
+	public int getEstimatedSize() {
 		return packetSize;
 	}
 
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet22Collect.java b/src/main/java/net/minecraft/core/net/packet/TakeItemEntityPacket.java
similarity index 59%
rename from src/main/java/net/minecraft/core/net/packet/Packet22Collect.java
rename to src/main/java/net/minecraft/core/net/packet/TakeItemEntityPacket.java
index 25cb1873c..66ad9f834 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet22Collect.java
+++ b/src/main/java/net/minecraft/core/net/packet/TakeItemEntityPacket.java
@@ -1,20 +1,20 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet22Collect extends Packet
+public class TakeItemEntityPacket extends Packet
 {
 
-    public Packet22Collect()
+    public TakeItemEntityPacket()
     {
     }
     
-    public Packet22Collect(int i, int j)
+    public TakeItemEntityPacket(int i, int j)
     {
         collectedEntityId = i;
         collectorEntityId = j;
@@ -22,7 +22,7 @@ public class Packet22Collect extends Packet
 
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         collectedEntityId = dis.readInt();
@@ -30,7 +30,7 @@ public class Packet22Collect extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeInt(collectedEntityId);
@@ -38,13 +38,13 @@ public class Packet22Collect extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleCollect(this);
+        packetHandler.handleCollect(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 8;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/TeleportEntityPacket.java b/src/main/java/net/minecraft/core/net/packet/TeleportEntityPacket.java
new file mode 100644
index 000000000..ae9f23aae
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/packet/TeleportEntityPacket.java
@@ -0,0 +1,81 @@
+package net.minecraft.core.net.packet;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.net.handler.PacketHandler;
+
+import java.io.*;
+
+// Referenced classes of package net.minecraft.src:
+//            Packet, Entity, MathHelper, PacketHandler
+
+public class TeleportEntityPacket extends Packet
+{
+    public int id;
+    public int x;
+    public int y;
+    public int z;
+    public byte yaw;
+    public byte pitch;
+
+    public TeleportEntityPacket()
+    {
+    }
+
+    public TeleportEntityPacket(Entity entity)
+    {
+        id = entity.id;
+        x = MathHelper.floor(entity.x * 32D);
+        y = MathHelper.floor(entity.y * 32D);
+        z = MathHelper.floor(entity.z * 32D);
+        yaw = (byte)(int)((entity.yRot * 256F) / 360F);
+        pitch = (byte)(int)((entity.xRot * 256F) / 360F);
+    }
+    
+    public TeleportEntityPacket(int id, int x, int y, int z, byte yaw, byte pitch)
+    {
+        this.id = id;
+        this.x = x;
+        this.y = y;
+        this.z = z;
+        this.yaw = yaw;
+        this.pitch = pitch;
+    }
+
+    @Override
+	public void read(DataInputStream dis)
+        throws IOException
+    {
+        id = dis.readInt();
+        x = dis.readInt();
+        y = dis.readInt();
+        z = dis.readInt();
+        yaw = (byte) dis.read();
+        pitch = (byte) dis.read();
+    }
+
+    @Override
+	public void write(DataOutputStream dos)
+        throws IOException
+    {
+        dos.writeInt(id);
+        dos.writeInt(x);
+        dos.writeInt(y);
+        dos.writeInt(z);
+        dos.write(yaw);
+        dos.write(pitch);
+    }
+
+    @Override
+	public void handlePacket(PacketHandler packetHandler)
+    {
+        packetHandler.handleEntityTeleport(this);
+    }
+
+    @Override
+	public int getEstimatedSize()
+    {
+        return 34;
+    }
+
+}
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet107UpdateCreativeInventory.java b/src/main/java/net/minecraft/core/net/packet/UpdateCreativeInventoryPacket.java
similarity index 58%
rename from src/main/java/net/minecraft/core/net/packet/Packet107UpdateCreativeInventory.java
rename to src/main/java/net/minecraft/core/net/packet/UpdateCreativeInventoryPacket.java
index 3a4d06e7d..72332b072 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet107UpdateCreativeInventory.java
+++ b/src/main/java/net/minecraft/core/net/packet/UpdateCreativeInventoryPacket.java
@@ -1,20 +1,20 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet107UpdateCreativeInventory extends Packet
+public class UpdateCreativeInventoryPacket extends Packet
 {
 
-    public Packet107UpdateCreativeInventory()
+    public UpdateCreativeInventoryPacket()
     {
     }
 
-    public Packet107UpdateCreativeInventory(int windowId, int page, String searchText)
+    public UpdateCreativeInventoryPacket(int windowId, int page, String searchText)
     {
         this.windowId = windowId;
         this.page = page;
@@ -22,13 +22,13 @@ public class Packet107UpdateCreativeInventory extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleUpdateCreativeInventory(this);
+        packetHandler.handleUpdateCreativeInventory(this);
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         windowId = dis.readByte();
@@ -37,7 +37,7 @@ public class Packet107UpdateCreativeInventory extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeByte(windowId);
@@ -46,7 +46,7 @@ public class Packet107UpdateCreativeInventory extends Packet
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 4 + 4 + searchText.length() * 2;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet72UpdatePlayerProfile.java b/src/main/java/net/minecraft/core/net/packet/UpdatePlayerProfilePacket.java
similarity index 70%
rename from src/main/java/net/minecraft/core/net/packet/Packet72UpdatePlayerProfile.java
rename to src/main/java/net/minecraft/core/net/packet/UpdatePlayerProfilePacket.java
index af4ab47ac..6d50b13b8 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet72UpdatePlayerProfile.java
+++ b/src/main/java/net/minecraft/core/net/packet/UpdatePlayerProfilePacket.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.server.util.helper.PlayerList;
 
 import java.io.DataInputStream;
@@ -8,16 +8,16 @@ import java.io.DataOutputStream;
 import java.io.IOException;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet72UpdatePlayerProfile extends Packet
+public class UpdatePlayerProfilePacket extends Packet
 {
 
-    public Packet72UpdatePlayerProfile()
+    public UpdatePlayerProfilePacket()
     {
     }
 
-    public Packet72UpdatePlayerProfile(String username, String nickname, int score, byte chatColor, boolean isOnline, boolean isOperator)
+    public UpdatePlayerProfilePacket(String username, String nickname, int score, byte chatColor, boolean isOnline, boolean isOperator)
     {
         this.username = username;
         this.nickname = nickname;
@@ -29,7 +29,7 @@ public class Packet72UpdatePlayerProfile extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
             throws IOException
     {
         username = readString(dis, 16);
@@ -41,7 +41,7 @@ public class Packet72UpdatePlayerProfile extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
             throws IOException
     {
         writeString(username, dos);
@@ -53,13 +53,13 @@ public class Packet72UpdatePlayerProfile extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleUpdatePlayerProfile(this);
+        packetHandler.handleUpdatePlayerProfile(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 6 + 4 + this.username.length() + 4;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet15Place.java b/src/main/java/net/minecraft/core/net/packet/UseItemPacket.java
similarity index 81%
rename from src/main/java/net/minecraft/core/net/packet/Packet15Place.java
rename to src/main/java/net/minecraft/core/net/packet/UseItemPacket.java
index 9a9c35e9e..1747885cd 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet15Place.java
+++ b/src/main/java/net/minecraft/core/net/packet/UseItemPacket.java
@@ -5,20 +5,20 @@ import java.io.DataOutputStream;
 import java.io.IOException;
 
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.util.helper.Direction;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, ItemStack, NetHandler
+//            Packet, ItemStack, PacketHandler
 
-public class Packet15Place extends Packet
+public class UseItemPacket extends Packet
 {
 
-    public Packet15Place()
+    public UseItemPacket()
     {
     }
 
-    public Packet15Place(int i, int j, int k, Direction direction, ItemStack itemstack, double xPlaced, double yPlaced)
+    public UseItemPacket(int i, int j, int k, Direction direction, ItemStack itemstack, double xPlaced, double yPlaced)
     {
         xPosition = i;
         yPosition = j;
@@ -30,7 +30,7 @@ public class Packet15Place extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         xPosition = dis.readInt();
@@ -52,7 +52,7 @@ public class Packet15Place extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeInt(xPosition);
@@ -73,13 +73,13 @@ public class Packet15Place extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handlePlace(this);
+        packetHandler.handlePlace(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 19;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/WeatherEffectPacket.java b/src/main/java/net/minecraft/core/net/packet/WeatherEffectPacket.java
new file mode 100644
index 000000000..86e7a71d2
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/packet/WeatherEffectPacket.java
@@ -0,0 +1,73 @@
+package net.minecraft.core.net.packet;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.LightningEntity;
+import net.minecraft.core.net.handler.PacketHandler;
+import net.minecraft.core.util.helper.MathHelper;
+
+import java.io.*;
+
+// Referenced classes of package net.minecraft.src:
+//            Packet, Entity, MathHelper, LightningEntity,
+//            PacketHandler
+
+public class WeatherEffectPacket extends Packet
+{
+    public static final int EFFECT_LIGHTNING = 1;
+    public int id;
+    public int x;
+    public int y;
+    public int z;
+    public int effectId;
+    public WeatherEffectPacket()
+    {
+    }
+
+    public WeatherEffectPacket(Entity entity)
+    {
+        id = entity.id;
+        x = MathHelper.floor(entity.x * 32D);
+        y = MathHelper.floor(entity.y * 32D);
+        z = MathHelper.floor(entity.z * 32D);
+        if(entity instanceof LightningEntity)
+        {
+            effectId = EFFECT_LIGHTNING;
+        }
+    }
+
+    @Override
+	public void read(DataInputStream dis)
+        throws IOException
+    {
+        id = dis.readInt();
+        effectId = dis.readByte();
+        x = dis.readInt();
+        y = dis.readInt();
+        z = dis.readInt();
+    }
+
+    @Override
+	public void write(DataOutputStream dos)
+        throws IOException
+    {
+        dos.writeInt(id);
+        dos.writeByte(effectId);
+        dos.writeInt(x);
+        dos.writeInt(y);
+        dos.writeInt(z);
+    }
+
+    @Override
+	public void handlePacket(PacketHandler packetHandler)
+    {
+        packetHandler.handleWeather(this);
+    }
+
+    @Override
+	public int getEstimatedSize()
+    {
+        return 17;
+    }
+
+
+}
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet73WeatherStatus.java b/src/main/java/net/minecraft/core/net/packet/WeatherStatusPacket.java
similarity index 64%
rename from src/main/java/net/minecraft/core/net/packet/Packet73WeatherStatus.java
rename to src/main/java/net/minecraft/core/net/packet/WeatherStatusPacket.java
index b72aedbcf..13b74cafd 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet73WeatherStatus.java
+++ b/src/main/java/net/minecraft/core/net/packet/WeatherStatusPacket.java
@@ -1,21 +1,27 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, Entity, MathHelper, EntityLightningBolt, 
-//            NetHandler
+//            Packet, Entity, MathHelper, LightningEntity,
+//            PacketHandler
 
-public class Packet73WeatherStatus extends Packet
+public class WeatherStatusPacket extends Packet
 {
+    public int dimId;
+    public int id;
+    public int newId;
+    public long duration;
+    public float intensity;
+    public float power;
 
-    public Packet73WeatherStatus()
+    public WeatherStatusPacket()
     {
     }
 
-    public Packet73WeatherStatus(int dimId, int id, int newId, long duration, float intensity, float power)
+    public WeatherStatusPacket(int dimId, int id, int newId, long duration, float intensity, float power)
     {
     	this.dimId = dimId;
         this.id = id;
@@ -26,7 +32,7 @@ public class Packet73WeatherStatus extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
     	dimId = dis.readInt();
@@ -38,7 +44,7 @@ public class Packet73WeatherStatus extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
     	dos.writeInt(dimId);
@@ -50,21 +56,14 @@ public class Packet73WeatherStatus extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleWeatherStatus(this);
+        packetHandler.handleWeatherStatus(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 28;
     }
-
-    public int dimId;
-    public int id;
-    public int newId;
-    public long duration;
-    public float intensity;
-    public float power;
 }
diff --git a/src/main/java/net/minecraft/core/player/Session.java b/src/main/java/net/minecraft/core/player/Session.java
index c901c2176..faca8af03 100644
--- a/src/main/java/net/minecraft/core/player/Session.java
+++ b/src/main/java/net/minecraft/core/player/Session.java
@@ -1,53 +1,15 @@
 package net.minecraft.core.player;
 
-import net.minecraft.core.block.Block;
-
-import java.util.ArrayList;
-import java.util.List;
-
 public class Session
 {
 
+    public String username;
+    public String sessionId;
     public Session(String username, String sessionId)
     {
         this.username = username;
         this.sessionId = sessionId;
     }
 
-    public static List<Block> registeredBlocksList;
-    public String username;
-    public String sessionId;
-
-    static
-    {
-        registeredBlocksList = new ArrayList<>();
-        registeredBlocksList.add(Block.stone);
-        registeredBlocksList.add(Block.cobbleStone);
-        registeredBlocksList.add(Block.brickClay);
-        registeredBlocksList.add(Block.dirt);
-        registeredBlocksList.add(Block.planksOak);
-        registeredBlocksList.add(Block.logOak);
-        registeredBlocksList.add(Block.leavesOak);
-        registeredBlocksList.add(Block.torchCoal);
-        registeredBlocksList.add(Block.glass);
-        registeredBlocksList.add(Block.cobbleStoneMossy);
-        registeredBlocksList.add(Block.saplingOak);
-        registeredBlocksList.add(Block.flowerYellow);
-        registeredBlocksList.add(Block.flowerRed);
-        registeredBlocksList.add(Block.mushroomBrown);
-        registeredBlocksList.add(Block.mushroomRed);
-        registeredBlocksList.add(Block.sand);
-        registeredBlocksList.add(Block.gravel);
-        registeredBlocksList.add(Block.spongeDry);
-        registeredBlocksList.add(Block.wool);
-        registeredBlocksList.add(Block.oreCoalStone);
-        registeredBlocksList.add(Block.oreIronStone);
-        registeredBlocksList.add(Block.oreGoldStone);
-        registeredBlocksList.add(Block.blockIron);
-        registeredBlocksList.add(Block.blockGold);
-        registeredBlocksList.add(Block.bookshelfPlanksOak);
-        registeredBlocksList.add(Block.tnt);
-        registeredBlocksList.add(Block.obsidian);
-    }
 
 }
